﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.NetworkInformation;
using System.Configuration;
using System.IO;
using System.Threading;

namespace TataAutoLoginApp
{
    
    public partial class Main : Form
    {
        static System.Threading.Mutex mutex;
        private static int WM_QUERYENDSESSION = 0x11;
        bool systemShutdown = false;

        uint count = 0;
        ushort baloonount = 0;
        int intervalsINT;
        bool IsConnAval;
        bool IsALoginEvent = false;
        bool AutoLogin;
        bool UserLoginCmd;
        bool Check = false;
        bool IsValidCredit = true;
        string username, password, domain;
        string urlLogin;
        string urlLogoff;
        System.Timers.Timer timerCheckConnection;
        Thread tLogin;
        Setting setting;
        PingReply prInternal;
        System.Diagnostics.Process processLAN;
        public static string appPath = System.IO.Directory.GetCurrentDirectory();

        public Main()
        {
            
            if (IsAlreadyRunning())
            {
                MessageBox.Show("Application already running.", "Tata Auto Login", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Environment.Exit(0);
            }
            InitializeComponent();

            processLAN = new System.Diagnostics.Process();
            processLAN.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
            processLAN.StartInfo.FileName = appPath + @"\repairLAN.bat";

            if (ConfigurationManager.AppSettings["onURL"] != null)
                urlLogin = ConfigurationManager.AppSettings["onURL"];
            else
                urlLogin = Properties.Resources.urlLogin;

            if (ConfigurationManager.AppSettings["offURL"] != null)
                urlLogoff = ConfigurationManager.AppSettings["offURL"];
            else
                urlLogoff = Properties.Resources.urlLogoff;


            username = ConfigurationManager.AppSettings["username"];
            domain = ConfigurationManager.AppSettings["domain"];
            password = PassResolver.getPassword();

            string intervals = ConfigurationManager.AppSettings["Intervals"];
            if (!int.TryParse(intervals, out intervalsINT) || intervalsINT < 10 || intervalsINT > 9999999)
                intervalsINT = 60;

            timerCheckConnection = new System.Timers.Timer();
            timerCheckConnection.Elapsed += new System.Timers.ElapsedEventHandler(timerCheckConnection_Elapsed);
            timerCheckConnection.AutoReset = true;

            tLogin = new Thread(new ThreadStart(Login));

            if (ConfigurationManager.AppSettings["AutoLoginCkeck"] == "False")
            {
                AutoLogin = false;
            }
            else
            {
                AutoLogin = true;
            }

            if (ConfigurationManager.AppSettings["AutoConnect"] == "False")
                Check = true;
            else
            {
                IsALoginEvent = true;
                UserLoginCmd = true;
            }

                timerCheckConnection.Interval = 500;
                timerCheckConnection.Start();
        }

        void setting_settingApplied(object sender, EventArgs e)
        {
            timerCheckConnection.Interval = setting.Intervals * 1000;
            intervalsINT = setting.Intervals;
            AutoLogin = setting.AutoLogin;
            username = setting.Username;
            password = setting.Password;
            domain = setting.Domain;

            if (AutoLogin == true)
            {
                timerCheckConnection.Interval = 1;
                timerCheckConnection.Start();
            }
            else
                timerCheckConnection.Interval = 1;
        }


        void timerCheckConnection_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            timerCheckConnection.Stop();
            IsConnAval = isConnectionAvailable();

            if (count > 2 && IsALoginEvent && (AutoLogin || UserLoginCmd))
            {
                if (count % 2 == 0)
                {
                    if (IsUserPassGiven())
                        if (tLogin.ThreadState != ThreadState.Running)
                            if (tLogin.ThreadState == ThreadState.Suspended)
                                tLogin.Resume();
                            else
                                tLogin.Start();
                }
                else
                {
                    if (!IsValidCredit)
                    {
                        //MessageBox.Show("Error: Invalid username or password.", "Tata Auto Login", MessageBoxButtons.OK,
                        //MessageBoxIcon.Stop);
                        Check = true;
                        IsALoginEvent = false;
                        notifyIcon1.BalloonTipIcon = ToolTipIcon.Error;
                        notifyIcon1.BalloonTipText = "Error: Invalid username or password.";

                        toolStripStatusLabel3.ToolTipText = "Error: Invalid username or password.";
                        toolStripStatusLabel3.Visible = true;
                        timerCheckConnection.Interval = 30000;
                        timerCheckConnection.Start();
                        notifyIcon1.ShowBalloonTip(15000);
                        return;
                    }
                    notifyIcon1.BalloonTipIcon = ToolTipIcon.Error;
                    notifyIcon1.BalloonTipText = "Error: Connection Unavailable.";
                    toolStripStatusLabel3.ToolTipText = "Error: Connection Unavailable.";
                    toolStripStatusLabel3.Visible = true;
                    timerCheckConnection.Interval = 30000;
                    timerCheckConnection.Start();
                    notifyIcon1.ShowBalloonTip(15000);
                }
            }
            else if (IsALoginEvent && !IsConnAval && (AutoLogin || UserLoginCmd))
            {
                if (IsUserPassGiven())
                    if (tLogin.ThreadState != ThreadState.Running)
                        if (tLogin.ThreadState == ThreadState.Suspended)
                            tLogin.Resume();
                        else
                            tLogin.Start();
            }
            else if (IsALoginEvent && IsConnAval && AutoLogin)
            {

                timerCheckConnection.Interval = intervalsINT * 1000;
                timerCheckConnection.Start();
            }
            else if (!IsALoginEvent && IsConnAval && !Check)
                LogOff();
            else
            {
                Check = true;
                timerCheckConnection.Interval = 30000;
                timerCheckConnection.Start();
            }

            if (!AutoLogin && IsConnAval && IsALoginEvent)
            {
                toolStripStatusLabel2.Visible = true;
                notifyIcon1.BalloonTipIcon = ToolTipIcon.Warning;
                notifyIcon1.BalloonTipText = "Warning: AutoLogin is disabled.";
                if (baloonount < 3)
                {
                    notifyIcon1.ShowBalloonTip(15000);
                    baloonount++;
                }
            }
            else
            {
                toolStripStatusLabel2.Visible = false;
                baloonount = 0;
            }

        }

        private bool isConnectionAvailable()
        {
            
            bool success = false;
            string[] sitesList = { "tataindicom.com", "google.com" };
            Ping ping = new Ping();
            PingReply reply;

            int notReturned = 0;
            try
            {
                try
                {
                    foreach (string domain in sitesList)
                    {
                        reply = ping.Send(domain, 2000);
                        if (reply.Status != IPStatus.Success)
                            notReturned += 1;
                        else
                            break;

                    }

                }
                catch
                {
                    toolStripStatusLabel1.ForeColor = Color.Red;
                    toolStripStatusLabel1.Text = "Disconnected.";
                    notifyIcon1.Text = "Tata Auto Login - Disconnected.";
                    notifyIcon1.Icon = Properties.Resources.tata_dc;
                    prInternal = ping.Send("tataindicombroadband.in", 2000);
                    if (prInternal.Status != IPStatus.Success)
                        processLAN.Start();
                    //processLAN.WaitForExit(5000);
                    //processLAN.Kill();
                    count++;
                    return false;
                }
                if (notReturned == sitesList.Length)
                {
                    toolStripStatusLabel1.ForeColor = Color.Red;
                    toolStripStatusLabel1.Text = "Disconnected.";
                    notifyIcon1.Text = "Tata Auto Login - Disconnected.";
                    notifyIcon1.Icon = Properties.Resources.tata_dc;
                    prInternal = ping.Send("tataindicombroadband.in", 2000);
                    if (prInternal.Status != IPStatus.Success)
                         processLAN.Start();
                    //processLAN.WaitForExit(5000);
                    //processLAN.Kill();
                    count++;
                    success = false;
                }
                else
                {
                    count = 0;
                    UserLoginCmd = false;
                    notifyIcon1.Icon = Properties.Resources.tata_c;
                    toolStripStatusLabel1.ForeColor = Color.Black;
                    toolStripStatusLabel1.Text = "Connected.";
                    notifyIcon1.Text = "Tata Auto Login - Connected.";
                    toolStripStatusLabel3.Visible = false;
                    success = true;
                }
            }
            catch
            {
                prInternal = null;
                count++;
                processLAN.Start();
                return false;
            }
            return success;
        }

        private void Login()
        {
            
            while (true)
            {
                toolStripStatusLabel1.ForeColor = Color.Black;
                toolStripStatusLabel1.Text = "Connecting...";
                notifyIcon1.Text = "Tata Auto Login - Connecting...";
                timerCheckConnection.Stop();
                //goOnline();
                
                IsALoginEvent = true;
                Check = false;
                StreamReader sr = null;
                try
                {
                    WebRequest oRequest = WebRequest.Create(urlLogin);
                    oRequest.Method = "POST";
                    oRequest.ContentType = "application/x-www-form-urlencoded";

                    string postdata = "username=" + username + "@" + domain + "&password=" + password;
                    oRequest.ContentLength = postdata.Length;

                    StreamWriter sw = new StreamWriter(oRequest.GetRequestStream());
                    sw.Write(postdata);
                    sw.Close();
                    oRequest.Timeout = 5000;
                    HttpWebResponse oResponse = (HttpWebResponse)oRequest.GetResponse();
                    sr = new StreamReader(oResponse.GetResponseStream());
                }
                catch { }
                finally
                {
                    string temp = "";
                    if (sr != null)
                        temp = sr.ReadToEnd();
                    if (temp.Contains("sorry.jpg"))
                        IsValidCredit = false;
                    else
                        IsValidCredit = true;

                    timerCheckConnection.Interval = 1000;
                    timerCheckConnection.Start();
                    tLogin.Suspend();
                }
            }
        }

        private void Main_Shown(object sender, EventArgs e)
        {
            this.Hide();
        }

        private void notifyIcon1_DoubleClick(object sender, EventArgs e)
        {
            this.Show();
            this.WindowState = FormWindowState.Normal;
        }


        private void Main_SizeChanged(object sender, EventArgs e)
        {
            if (WindowState == FormWindowState.Minimized)
                this.Hide();
        }

        private void buttonSetting_Click(object sender, EventArgs e)
        {
            if (setting == null || setting.IsDisposed)
            {
                //goOnline();
                setting = new Setting();
                setting.Owner = this;
                setting.settingApplied += new EventHandler(setting_settingApplied);
                setting.Show();
            }

        }

        private void contextMenuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            if (contextMenuStrip1.Items["toolStripMenuItem1"].ToString() == e.ClickedItem.ToString())
            {
                Environment.Exit(0);
            }
            if (contextMenuStrip1.Items["toolStripMenuItem2"].ToString() == e.ClickedItem.ToString())
            {
                if (setting == null || setting.IsDisposed)
                {
                    //goOnline();
                    setting = new Setting();
                    setting.settingApplied += new EventHandler(setting_settingApplied);
                    setting.Show();
                }
            }
            if (contextMenuStrip1.Items["toolStripMenuItem3"].ToString() == e.ClickedItem.ToString())
            {
                count = 0;
                UserLoginCmd = true;
                if (IsUserPassGiven())
                    if (tLogin.ThreadState != ThreadState.Running)
                        if (tLogin.ThreadState == ThreadState.Suspended)
                            tLogin.Resume();
                        else
                            tLogin.Start();
            }
            if (contextMenuStrip1.Items["toolStripMenuItem4"].ToString() == e.ClickedItem.ToString())
            {
                LogOff();
            }
        }

        private void buttonLogin_Click(object sender, EventArgs e)
        {
            count = 0;
            UserLoginCmd = true;
            if (IsUserPassGiven())
                if (tLogin.ThreadState != ThreadState.Running)
                    if (tLogin.ThreadState == ThreadState.Suspended)
                        tLogin.Resume();
                    else
                        tLogin.Start();

        }

        private void buttonlogOff_Click(object sender, EventArgs e)
        {
            LogOff();
        }


        void LogOff()
        {
            try
            {
                IsALoginEvent = false;
                timerCheckConnection.Interval = 3000;
                WebRequest oRequest = WebRequest.Create(urlLogoff);
                oRequest.Method = "POST";
                oRequest.ContentType = "application/x-www-form-urlencoded";

                string postdata = "confirmed=true";
                oRequest.ContentLength = postdata.Length;

                StreamWriter sw = new StreamWriter(oRequest.GetRequestStream());
                sw.Write(postdata);
                sw.Close();
                WebResponse oResponse = oRequest.GetResponse();
            }
            catch
            { }
            finally
            {
                timerCheckConnection.Start();
            }
        }


        private static bool IsAlreadyRunning()
        {
            string strLoc = System.Reflection.Assembly.GetExecutingAssembly().Location;
            System.IO.FileSystemInfo fileInfo = new System.IO.FileInfo(strLoc);
            string sExeName = fileInfo.Name;
            bool bCreatedNew;

            mutex = new System.Threading.Mutex(true, "Global\\" + sExeName, out bCreatedNew);
            if (bCreatedNew)
                mutex.ReleaseMutex();

            return !bCreatedNew;
        }

        private void Main_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (systemShutdown)
            {
                if (tLogin.ThreadState == ThreadState.Suspended)
                    tLogin.Resume();
                tLogin.Abort();
                return;
            }
            DialogResult = MessageBox.Show("Are you sure you want quit?", "Tata Auto Login", MessageBoxButtons.YesNo, MessageBoxIcon.Question);
            if (DialogResult != DialogResult.Yes)
                e.Cancel = true;
            else
            {
                if (tLogin.ThreadState == ThreadState.Suspended)
                    tLogin.Resume();
                tLogin.Abort();
            }
        }


        protected override void WndProc(ref Message m)
        {
            if (m.Msg == WM_QUERYENDSESSION)
                systemShutdown = true;
            base.WndProc(ref m);
        }

        private bool IsUserPassGiven()
        {
            if (password == null || username == null)
            {
                IsALoginEvent = false;
                Check = true;
                MessageBox.Show("Please enter 'username' and 'password' in setting window and press 'Login now'", "Tata Auto Login", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                timerCheckConnection.Interval = 30000;
                timerCheckConnection.Start();
                return false;
            }
            else
                return true;
        }
    }
}
