﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Configuration;
using RezaEN.TypeEncryption;

namespace TataAutoLoginApp
{
    public static class PassResolver
    {
        public static string getPassword()
        {
            string password = null;
            byte[] passwordByteArry = null;
            byte[] key = null;
            byte[] IV = null;
            ConfigurationManager.RefreshSection("appSettings");
            if (ConfigurationManager.AppSettings["password"] != null &&
               ConfigurationManager.AppSettings["key"] != null &&
               ConfigurationManager.AppSettings["IV"] != null)
            {
                //password = encoding.GetBytes(ConfigurationManager.AppSettings["password"]);
                //key = encoding.GetBytes(ConfigurationManager.AppSettings["key"]);
                //IV = encoding.GetBytes(ConfigurationManager.AppSettings["IV"]);

                //textBoxUsername.Text = ConfigurationManager.AppSettings["username"];
                char[] passCharArray = ConfigurationManager.AppSettings["password"].ToCharArray();
                passwordByteArry = new byte[passCharArray.Length];
                for (int ind = 0; ind < passCharArray.Length; ind++)
                    passwordByteArry[ind] = Convert.ToByte(passCharArray[ind]);

                char[] keyCharArray = ConfigurationManager.AppSettings["key"].ToCharArray();
                key = new byte[keyCharArray.Length];
                for (int ind = 0; ind < keyCharArray.Length; ind++)
                    key[ind] = Convert.ToByte(keyCharArray[ind]);

                char[] ivCharArray = ConfigurationManager.AppSettings["IV"].ToCharArray();
                IV = new byte[ivCharArray.Length];
                for (int ind = 0; ind < ivCharArray.Length; ind++)
                    IV[ind] = Convert.ToByte(ivCharArray[ind]);
            }
            try
            {
                password = StringEncryption.DecryptText(passwordByteArry, key, IV);
            }
            catch
            { }

            if (password != null)
                return password;
            else
                return null;
        }

        public static void setPassword(string password)
        {
            try
            {
                Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
                AppSettingsSection appSetting = config.AppSettings;
                byte[] key = null;
                byte[] IV = null;

                if (password != "")
                {
                    byte[] passwordByteArray = StringEncryption.EncryptText(password,
                        ref key, ref IV, false);
                    appSetting.Settings.Remove("password");
                    appSetting.Settings.Remove("key");
                    appSetting.Settings.Remove("IV");

                    char[] passCharArray = new char[passwordByteArray.Length];
                    for (int i = 0; i < passwordByteArray.Length; i++)
                        passCharArray[i] = Convert.ToChar(passwordByteArray[i]);
                    string passStr = new string(passCharArray);

                    char[] keyCharArray = new char[key.Length];
                    for (int i = 0; i < key.Length; i++)
                        keyCharArray[i] = Convert.ToChar(key[i]);
                    string keyStr = new string(keyCharArray);

                    char[] ivCharArray = new char[IV.Length];
                    for (int i = 0; i < IV.Length; i++)
                        ivCharArray[i] = Convert.ToChar(IV[i]);
                    string ivStr = new string(ivCharArray);

                    appSetting.Settings.Add("password", passStr);
                    appSetting.Settings.Add("key", keyStr);
                    appSetting.Settings.Add("IV", ivStr);
                }
                config.Save();
            }
            catch
            {
               // MessageBox.Show("Setting Login intervals failed.", "Tata Auto login", MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
        }

    }
}
