﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using RezaEN.TypeEncryption;
using System.Xml;
namespace TataAutoLoginApp
{
    public partial class Setting : Form
    {
        public event EventHandler settingApplied;
        int intervals;
        bool autoLogin;
        byte[] password;
        byte[] key;
        byte[] IV;

        public string Username
        {
            get
            {
                return textBoxUsername.Text;
            }
        }
        public string Password
        {
            get
            {
                return textBoxPassword.Text;
            }
        }
        public string Domain
        {
            get
            {
                return (string)comboBoxDomain.SelectedItem;
            }
        }
        public int Intervals
        {
            get
            {
                return intervals;
            }
        }
        public bool AutoLogin
        {
            get
            {
                return autoLogin;
            }
        }

        public Setting()
        {
            InitializeComponent();
            string appPath = Main.appPath;
            int i;
            ConfigurationManager.RefreshSection("appSettings");

            textBoxUsername.Text = ConfigurationManager.AppSettings["username"];
            textBoxPassword.Text = PassResolver.getPassword();

            foreach (object obj in comboBoxDomain.Items)
                if (obj.ToString() == ConfigurationManager.AppSettings["domain"])
                {
                    comboBoxDomain.SelectedItem = obj;
                    break;
                }
                else
                    comboBoxDomain.SelectedIndex = 0;


            string intervlsStr = ConfigurationManager.AppSettings["Intervals"];

            if (int.TryParse(intervlsStr, out i) && i > 9 && i < 10000000)
                textBox1.Text = intervlsStr;
            else
                textBox1.Text = "60";

            if (ConfigurationManager.AppSettings["AutoConnect"] == "False")
                checkBoxAutoConnect.Checked = false;
            else
                checkBoxAutoConnect.Checked = true;

            if (ConfigurationManager.AppSettings["AutoLoginCkeck"] == "False")
                checkBoxLoginCheck.Checked = false;
            else
            {
                checkBoxLoginCheck.Checked = true;
                textBox1.Enabled = true;
            }

            buttonApply.Enabled = false;
        }

       
        private void buttonApply_Click(object sender, EventArgs e)
        {
            errorProvider1.SetError(textBox1, "");
            if (!int.TryParse(textBox1.Text, out intervals) || intervals < 10 || intervals > 9999999)
            {
                errorProvider1.SetError(textBox1, "enter value greater than 9 sec");
                return;
            }
            else if (textBoxUsername.Text == "" || textBoxPassword.Text == "")
            {
                if (textBoxUsername.Text == "")
                    errorProvider1.SetError(textBoxUsername, "enter username.");
                if (textBoxPassword.Text == "")
                    errorProvider1.SetError(textBoxPassword, "enter password.");
                return;
            }
            else
            {
                try
                {
                    Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
                    AppSettingsSection appSetting = config.AppSettings;
                    
                    appSetting.Settings.Remove("username");
                    appSetting.Settings.Remove("domain");
                    appSetting.Settings.Remove("Intervals");
                    appSetting.Settings.Remove("AutoConnect");
                    appSetting.Settings.Remove("AutoLoginCkeck");
                    appSetting.Settings.Add("Intervals", textBox1.Text);
                    appSetting.Settings.Add("AutoConnect", checkBoxAutoConnect.Checked.ToString());
                    appSetting.Settings.Add("AutoLoginCkeck", checkBoxLoginCheck.Checked.ToString());

                    appSetting.Settings.Add("username", textBoxUsername.Text);
                    appSetting.Settings.Add("domain", (string)comboBoxDomain.SelectedItem);

                    config.Save();
                    PassResolver.setPassword(textBoxPassword.Text);
                    autoLogin = checkBoxLoginCheck.Checked;
                    settingApplied(this, EventArgs.Empty);
                }
                catch
                {
                    MessageBox.Show("Setting Login intervals failed.", "Tata Auto login", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                }
            }
            buttonApply.Enabled = false;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            buttonApply.Enabled = true;
        }

        private void checkBoxAutoConnect_CheckedChanged(object sender, EventArgs e)
        {
            buttonApply.Enabled = true;
        }

        private void checkBoxLoginCheck_CheckedChanged(object sender, EventArgs e)
        {
            buttonApply.Enabled = true;
            if (checkBoxLoginCheck.Checked)
                textBox1.Enabled = true;
            else
                textBox1.Enabled = false;
        }

        private void textBoxUsername_TextChanged(object sender, EventArgs e)
        {
            buttonApply.Enabled = true;
        }

        private void comboBoxDomain_SelectedIndexChanged(object sender, EventArgs e)
        {
            buttonApply.Enabled = true;
        }

        private void textBoxPassword_TextChanged(object sender, EventArgs e)
        {
            buttonApply.Enabled = true;
        }
    }
}
