﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.NetworkInformation;
using System.Configuration;

namespace TataAutoLoginApp
{
    public partial class Main : Form
    {
        static System.Threading.Mutex mutex;
        int i = 0;
        uint count = 0;
        int intervalsINT;
        bool IsALoginEvent;
        bool AutoLogin;
        bool maxCheck = false;
        System.Timers.Timer timerCheckConnection;
        System.Timers.Timer timerLogin;
        Icon iconTata;
        Icon iconTataDC;
        Setting setting;
        System.Diagnostics.Process processLAN;
        public static string  appPath = System.IO.Directory.GetCurrentDirectory();

        public Main()
        {
            if (IsAlreadyRunning())
            {
                MessageBox.Show("Application already running.","Tata Auto Login",MessageBoxButtons.OK,MessageBoxIcon.Error);
                Environment.Exit(0);
            }
            InitializeComponent();

            processLAN = new System.Diagnostics.Process();
            processLAN.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;
            processLAN.StartInfo.FileName = appPath + @"\repairLAN.bat";

            iconTata = new Icon(appPath + @"\tata-c.ico");
            iconTataDC = new Icon(appPath + @"\tata-dc.ico");

            webBrowser1.Navigated += new WebBrowserNavigatedEventHandler(webBrowser1_Navigated);
            this.webBrowser1.ScriptErrorsSuppressed = true;

            string intervals = ConfigurationManager.AppSettings["Intervals"];
            if (!int.TryParse(intervals, out intervalsINT) || intervalsINT < 10 || intervalsINT >9999999)
                intervalsINT = 60;

            timerCheckConnection = new System.Timers.Timer();
            timerCheckConnection.Elapsed += new System.Timers.ElapsedEventHandler(timerCheckConnection_Elapsed);
            timerCheckConnection.Interval = intervalsINT * 1000;
            timerCheckConnection.AutoReset = true;

            timerLogin = new System.Timers.Timer();
            timerLogin.Elapsed += new System.Timers.ElapsedEventHandler(timerLogin_Elapsed);
            timerLogin.Interval = 500;

            if (ConfigurationManager.AppSettings["AutoLoginCkeck"] == "False")
            {
                AutoLogin = false;
            }
            else
            {
                AutoLogin = true;
            }

            if (ConfigurationManager.AppSettings["AutoConnect"] != "False")
                Login();
        }

        void webBrowser1_Navigated(object sender, WebBrowserNavigatedEventArgs e)
        {
            if (i > 0)
            { webBrowser1.Stop(); i = 0; }
            else
                i++;
        }

        void timerLogin_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            timerLogin.Stop();
            label1.Invoke(new EventHandler(label1_Click));
        }

        void setting_settingApplied(object sender, EventArgs e)
        {
            timerCheckConnection.Interval = setting.intervals * 1000;
            intervalsINT = setting.intervals;
            AutoLogin = setting.autoLogin;
            if (AutoLogin == true)
            {
                timerCheckConnection.Interval = 1;
                timerCheckConnection.Start();
            }
            else
                timerCheckConnection.Interval = 1;
        }

        void goOnline()
        {
            Microsoft.Win32.RegistryKey rk = Microsoft.Win32.Registry.CurrentUser;
            rk = rk.OpenSubKey(@"Software\Microsoft\Windows\CurrentVersion\Internet Settings",true);
            rk.SetValue("GlobalUserOffline", 0);
            rk.Close();
        }

        void timerCheckConnection_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            timerCheckConnection.Stop();

            bool IsConnAval = isConnectionAvailable();

            if (count > 9 || maxCheck)
            {
                
                maxCheck = true;
                label1.Text = count.ToString();
                if (count%2 == 0)
                    Login();
                else
                {
                    notifyIcon1.BalloonTipIcon = ToolTipIcon.Error;
                    notifyIcon1.BalloonTipText = "Error: Connection Unavailable.";
                    notifyIcon1.ShowBalloonTip(15000);
                    toolStripStatusLabel3.Visible = true;
                    timerCheckConnection.Interval = 60000;
                    timerCheckConnection.Start();
                }
            }
            else if (IsALoginEvent && !IsConnAval)
                    Login();
            else if (IsALoginEvent && IsConnAval && AutoLogin)
            {
                timerCheckConnection.Interval = intervalsINT * 1000;
                timerCheckConnection.Start();
            }
            else if (!IsALoginEvent && IsConnAval)
                LogOff();

            if (!AutoLogin && IsConnAval && IsALoginEvent)
            {
                toolStripStatusLabel2.Visible = true;
                notifyIcon1.BalloonTipIcon = ToolTipIcon.Warning;
                notifyIcon1.BalloonTipText = "Warning: AutoLogin is disabled.";
                notifyIcon1.ShowBalloonTip(15000);
            }
            else
                toolStripStatusLabel2.Visible = false;
            
        }

        private bool isConnectionAvailable()
        {
            bool success = false;
            string[] sitesList = { "tataindicom.com","google.com" };
            Ping ping = new Ping();
            PingReply reply;

            int notReturned = 0;
            try
            {
                try
                {
                    foreach (string domain in sitesList)
                    {
                        reply = ping.Send(domain, 2000);
                        if (reply.Status != IPStatus.Success)
                            notReturned += 1;
                        else
                            break;

                    }

                }
                catch
                {
                    toolStripStatusLabel1.ForeColor = Color.Red;
                    toolStripStatusLabel1.Text = "Disconnected.";
                    notifyIcon1.Text = "Tata Auto Login - Disconnected.";
                    notifyIcon1.Icon = iconTataDC;
                    reply = ping.Send("tataindicombroadband.in", 2000);
                    if (reply.Status != IPStatus.Success)
                        processLAN.Start();
                    //processLAN.WaitForExit(5000);
                    //processLAN.Kill();
                    count++;
                    return false;
                }
                if (notReturned == sitesList.Length)
                {
                    toolStripStatusLabel1.ForeColor = Color.Red;
                    toolStripStatusLabel1.Text = "Disconnected.";
                    notifyIcon1.Text = "Tata Auto Login - Disconnected.";
                    notifyIcon1.Icon = iconTataDC;
                    reply = ping.Send("tataindicombroadband.in", 2000);
                    if (reply.Status != IPStatus.Success)
                        processLAN.Start();
                    //processLAN.WaitForExit(5000);
                    //processLAN.Kill();
                    count++;
                    success = false;
                }
                else
                {
                    count = 0;
                    maxCheck = false;
                    notifyIcon1.Icon = iconTata;
                    toolStripStatusLabel1.ForeColor = Color.Black;
                    toolStripStatusLabel1.Text = "Connected.";
                    notifyIcon1.Text = "Tata Auto Login - Connected.";
                    toolStripStatusLabel3.Visible = false;
                    success = true;
                }
            }
            catch
            {
                count++;
                processLAN.Start();
                return false;
            }
            return success;
        }

        private void Login()
        {
            timerCheckConnection.Stop();
            goOnline();
            IsALoginEvent = true;
            i = 0;
            this.webBrowser1.Navigate(appPath + @"\autologin-t2.htm", false);
            timerLogin.Start();
            timerCheckConnection.Interval = 3000;
            timerCheckConnection.Start();
        }

        private void Main_Shown(object sender, EventArgs e)
        {
            this.Hide();
        }

        private void notifyIcon1_DoubleClick(object sender, EventArgs e)
        {
            this.Show();
            this.WindowState = FormWindowState.Normal;
        }


        private void Main_SizeChanged(object sender, EventArgs e)
        {
            if (WindowState == FormWindowState.Minimized)
                this.Hide();
        }

        private void buttonSetting_Click(object sender, EventArgs e)
        {
            if (setting == null || setting.IsDisposed)
            {
                goOnline();
                setting = new Setting();
                setting.Owner = this;
                setting.settingApplied += new EventHandler(setting_settingApplied);
                setting.Show();
            }
                
        }

        private void contextMenuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            if (contextMenuStrip1.Items["toolStripMenuItem1"].ToString() == e.ClickedItem.ToString())
            {
                Environment.Exit(0);
            }
            if (contextMenuStrip1.Items["toolStripMenuItem2"].ToString() == e.ClickedItem.ToString())
            {
                if (setting == null || setting.IsDisposed)
                {
                    goOnline();
                    setting = new Setting();
                    setting.settingApplied += new EventHandler(setting_settingApplied);
                    setting.Show();
                }
            }
            if (contextMenuStrip1.Items["toolStripMenuItem3"].ToString() == e.ClickedItem.ToString())
            {
                count = 0;
                maxCheck = false;
                Login();
            }
            if (contextMenuStrip1.Items["toolStripMenuItem4"].ToString() == e.ClickedItem.ToString())
            {
                LogOff();
            }
        }

        private void buttonLogin_Click(object sender, EventArgs e)
        {
            count = 0;
            maxCheck = false;
            Login();
            
        }

        private void buttonlogOff_Click(object sender, EventArgs e)
        {
            LogOff();
        }


        void LogOff()
        {
            goOnline();
            IsALoginEvent = false;
            timerCheckConnection.Interval = 3000;
            webBrowser1.Navigate(appPath + @"\logoff-yn.htm");
            timerCheckConnection.Start();
        }

        
        private static bool IsAlreadyRunning()
        {
            string strLoc = System.Reflection.Assembly.GetExecutingAssembly().Location;
            System.IO.FileSystemInfo fileInfo = new System.IO.FileInfo(strLoc);
            string sExeName = fileInfo.Name;
            bool bCreatedNew;

            mutex = new System.Threading.Mutex(true, "Global\\" + sExeName, out bCreatedNew);
            if (bCreatedNew)
                mutex.ReleaseMutex();

            return !bCreatedNew;
        }

        private void label1_Click(object sender, EventArgs e)
        {
            if (webBrowser1.Document.GetElementById("user").GetAttribute("value") == "" ||
                webBrowser1.Document.GetElementById("ServerList").GetAttribute("value") == "select" ||
                webBrowser1.Document.GetElementById("password").GetAttribute("value") == "")
            {
                timerCheckConnection.Stop();
                MessageBox.Show("Enter UserName, Domain, Password in \"Setting\" form and click \"Login Now\"");
            }
            else
                webBrowser1.Document.GetElementById("imageField").InvokeMember("click");
        }

     }
}
